# Bfwd::BraintreeCaptureRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**created** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was created.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**organization_id** | **String** | {\&quot;description\&quot;:\&quot;ID of the BillForward Organization within which the requested PaymentMethod should be created. If omitted, this will be auto-populated using your authentication credentials.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**account_id** | **String** | {\&quot;description\&quot;:\&quot;ID of the BillForward Account with which you would like to associate the created payment method.&lt;br&gt;If omitted, BillForward will associate the created PaymentMethod with a newly-created Account, whose Profile details will be populated using billing information from the funding instrument.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**default_payment_method** | **BOOLEAN** | {\&quot;default\&quot;:false,\&quot;description\&quot;:\&quot;Whether the PaymentMethod produced by this request should be elected as the &#39;default&#39; payment method for the concerned BillForward Account. Whichever PaymentMethod is elected as an Account&#39;s default payment method, will be consulted whenever payment is demanded of that Account (i.e. upon the execution of any of the Account&#39;s invoices).\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] [default to false]
**cardholder_name** | **String** | {\&quot;description\&quot;:\&quot;Name of the person who holds the credit card being captured.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | 
**card_number** | **String** | {\&quot;description\&quot;:\&quot;Number of the credit card being captured.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | 
**expiry_month** | **String** | {\&quot;description\&quot;:\&quot;Expiration month of the credit card being captured, formatted MM.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | 
**expiry_year** | **String** | {\&quot;description\&quot;:\&quot;Expiration year of the credit card being captured, formatted YYYY or YY.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | 
**cvv** | **String** | {\&quot;description\&quot;:\&quot;3 or 4 digit card verification value assigned to the credit card being captured.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | 
**device_data** | **String** | {\&quot;description\&quot;:\&quot;(Required when vaulting a PayPal payment method; otherwise optional)&lt;br&gt;A JSON string providing information about the device your customer used to fill out the card capture form. This information is inserted into your form by &lt;a href&#x3D;\\\&quot;https://developers.braintreepayments.com/javascript+node/guides/advanced-fraud-tools/client-side\\\&quot;&gt;braintree-data.js&lt;/a&gt; &amp;mdash; if and only if you use Braintree&#39;s drop-in form integrations. You should ideally provide it if you have one (it aids with fraud detection), but it is only mandatory in the case of PayPal payment method vaulting.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**merchant_account_id** | **String** | {\&quot;description\&quot;:\&quot;Braintree &lt;a href&#x3D;\\\&quot;https://articles.braintreepayments.com/control-panel/important-gateway-credentials\\\&quot;&gt;Merchant account ID&lt;/a&gt; with which you wish for the captured funding instrument to transact. Within your Braintree gateway, you can have multiple merchant accounts to process transactions for different businesses or currencies. If you have a single merchant account, it is not necessary to specify a merchant account ID in your API requests. If you have multiple merchant accounts and choose not to specify the merchant account ID, all requests will process through your default merchant account.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**ip_address** | **String** | {\&quot;description\&quot;:\&quot;IP address of the customer providing the details of the credit card to be captured.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**ip_address_country** | **String** | {\&quot;description\&quot;:\&quot;Country of the IP address of the customer providing the details of the credit card to be captured.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 


