# Bfwd::Coupon

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**created** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was created.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**changed_by** | **String** | { \&quot;description\&quot; : \&quot;ID of the user who last updated the entity.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**updated** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was last updated.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**name** | **String** | { \&quot;description\&quot; : \&quot;\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;] } | 
**coupon_code** | **String** | { \&quot;description\&quot; : \&quot;Code used to identify this set of coupons. If unique codes are required this will be used as the prefix to generate individual coupon codes. When a unique code is returned the original couponCode is returned in the parentCouponCode property. For example a single coupon code SUMMER maybe be issued at an event to encourage sign-up, the same code can be redeemed by multiple accounts. In another example you may want to issue unique coupon codes per a customer, for example SUMMER-A4FC, SUMMER-BCQ4, each code can only be calimed once.\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;] } | 
**coupons** | **Integer** | { \&quot;default\&quot; : \&quot;&amp;infin;\&quot;, \&quot;description\&quot; : \&quot;Number of times the coupon can be claimed. In the case of generating unique coupon codes this is the maximum quantity that can be genereated. For example set this value to 10 if you want to limit the total number of subscriptions that will use this code to 10.\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;] } | 
**uses** | **Integer** | { \&quot;default\&quot; : \&quot;&amp;infin;\&quot;, \&quot;description\&quot; : \&quot;This specifies how many times a discount will be added to a subscription once the coupon is added. For example if the uses is set to 3 it will discount 3 times, set this to a large number, for example 9999999, to give infinite applications, .\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;] } | 
**product** | **String** | { \&quot;description\&quot; : \&quot;Name or ID of the product this coupon applies to. Requires a specific rate-plan to be set.\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;] } | [optional] 
**product_name** | **String** | { \&quot;description\&quot; : \&quot;\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 
**product_id** | **String** | { \&quot;description\&quot; : \&quot;\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 
**product_rate_plan** | **String** | { \&quot;description\&quot; : \&quot;Name or ID of the rate-plan this coupon applies to. \&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;] } | [optional] 
**product_rate_plan_name** | **String** | { \&quot;description\&quot; : \&quot;\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 
**product_rate_plan_id** | **String** | { \&quot;description\&quot; : \&quot;\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 
**currency** | **String** | { \&quot;description\&quot; : \&quot;If the coupon is not for a specific rate-plan, and can apply to any subscription, the currency should be provivded. Currency is specified by a three character ISO 4217 currency code.\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;] } | [optional] 
**parent_coupon_code_redeemable** | **BOOLEAN** | {  \&quot;default\&quot; : \&quot;true\&quot;, \&quot;description\&quot; : \&quot;If true the coupon without postfix can be added to a subscription, for example if parentCouponCodeRedeemable is true and the coupon was created with code SUMMER customers could claim using SUMMER. If parentCouponCodeRedeemable is false then only unique coupon codes can be claimed, for example SUMMER-AB4C, SUMMER-YZB4.\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;] } | [default to false]
**organization_id** | **String** |  | 
**discounts** | [**Array&lt;CouponDiscount&gt;**](CouponDiscount.md) | { \&quot;description\&quot; : \&quot;For each discount item on the coupon, only one discount type should be set between cashDiscount, percentageDiscount and unitsFree. cashDiscount gives a fixed monetary discount, for example $10.00. percentageDiscount gives a percentage discount on the overall invoice cost. unitsFree discounts the pricing by the number of units specified for that component. All discounts are applied against the base cost or units. Discounts are not compound. Discounts will never exceed the value of a pricing component of the overall invoice - thus at most the discount will reduce the cost to zero. If no pricing component is specified the discount will apply to the total invoice cost.\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;] } | 
**deleted** | **BOOLEAN** | { \&quot;description\&quot; : \&quot;If a coupon has been deleted, any subsequent attempts to add it to a subscription will fail. Note: This will not affect existing subscription using the coupon. Please see deleting a coupon for more details\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] [default to false]
**parent_coupon_code** | **String** | { \&quot;description\&quot; : \&quot;For unique coupon codes this is the original coupon code, for example SUMMER\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 
**applies_to** | **String** | { \&quot;description\&quot; : \&quot;For unique coupon codes this is what the coupon applies to, usually subscription.\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 
**applies_to_id** | **String** | { \&quot;description\&quot; : \&quot;For a coupon added to a subscription this is the the ID of the subscription. This can be used to remove the coupon from the target.\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 
**remaining_uses** | **Integer** | {  \&quot;description\&quot; : \&quot;\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 
**used** | **Integer** | {  \&quot;description\&quot; : \&quot;\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 
**discount_value** | **Float** |  | [optional] 
**valid_until** | **DateTime** | { \&quot;description\&quot; : \&quot;If the coupon was removed from the subscription this is the date and time from when it no ceased to be applied.\&quot;, \&quot;verbs\&quot;:[\&quot;GET\&quot;] } | [optional] 


