# Bfwd::CreateAggregatingSubscriptionRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**created** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was created.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**account_id** | **String** | {\&quot;description\&quot;:\&quot;ID of the BillForward Account who will own this aggregating subscription. You should ensure beforehand that the customer has had a BillForward Account created for them.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | 
**organization_id** | **String** | {\&quot;default\&quot;:\&quot;(Auto-populated using your authentication credentials)\&quot;,\&quot;description\&quot;:\&quot;ID of the BillForward Organization within which the requested Subscription should be created. If omitted, this will be auto-populated using your authentication credentials.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**name** | **String** | {\&quot;default\&quot;:\&quot;(Subscription will be named after the rate plan to which the subscription subscribes)\&quot;,\&quot;description\&quot;:\&quot;Name of the created subscription. This is primarily for your benefit &amp;mdash; for example, to enable you to identify subscriptions at a glance in the BillForward web interface (e.g. &#39;BusinessCorp subscriptions, care of Mr Business (mr@busy.com)&#39;).\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**description** | **String** | {\&quot;default\&quot;:\&quot;(null)\&quot;,\&quot;description\&quot;:\&quot;Description of the created subscription. This is primarily for your benefit &amp;mdash; for example, you could write here the mechanism through which you obtained this customer. (e.g. &#39;Business signed up using BUSYGUYS coupon, at management trade show&#39;).\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**start** | **DateTime** | {\&quot;default\&quot;:\&quot;(ServerNow upon receiving request)\&quot;,\&quot;description\&quot;:\&quot;ISO 8601 UTC DateTime (e.g. 2015-06-16T11:58:41Z) describing the date at which the subscription should enter its first service period.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**state** | **String** | {\&quot;default\&quot;:\&quot;Provisioned\&quot;,\&quot;description\&quot;:\&quot;The state in which the created subscription will begin.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Provisioned&lt;/span&gt; &amp;mdash; The subscription will wait (without raising any invoices or beginning its service) until explicit action is taken to change its state.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;AwaitingPayment&lt;/span&gt; &amp;mdash; The subscription is activated. After &#x60;start&#x60; time is surpassed, it will begin service and raise its first invoice.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**product_rate_plan** | **String** | {\&quot;description\&quot;:\&quot;ID of the rate plan to which the subscription will be subscribing. If omitted: it will be assumed you wish to create a new rate plan as part of this request &amp;mdash; this subscription will subscribe to that newly-created rate plan.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**duration** | **Integer** | {\&quot;description\&quot;:\&quot;[Required if and only if &#x60;productRatePlan&#x60; is omitted] Number of length-measures which constitute the rate plan&#39;s period.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**duration_period** | **String** | {\&quot;description\&quot;:\&quot;[Required if and only if &#x60;productRatePlan&#x60; is omitted] Measure describing the magnitude of the rate plan&#39;s period.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**product_type** | **String** | {\&quot;description\&quot;:\&quot;[Required if and only if &#x60;productRatePlan&#x60; is omitted] The frequency of the rate plan &amp;mdash; either recurring or non-recurring.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**aggregating_components** | [**Array&lt;CreateAggregatingComponentRequest&gt;**](CreateAggregatingComponentRequest.md) | {\&quot;default\&quot;:\&quot;(empty list)\&quot;,\&quot;description\&quot;:\&quot;[Required if and only if &#x60;productRatePlan&#x60; is omitted] List of components whose prices should be recalculated upon invoice aggregation. For example: two subscriptions&#39; individual consumptions may neither of them be large enough to achieve bulk buy discounts. When aggregated, though, the same two subscriptions&#39; consumption may add up to a quantity which does merit a bulk buy discount within your tiering system.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**aggregate_all_subscriptions_on_account** | **BOOLEAN** | {\&quot;default\&quot;:false,\&quot;description\&quot;:\&quot;Whether this &#39;aggregating subscription&#39; should collect charges (starting now) from all other subscriptions (current and future) belonging to this BillForward Account.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] [default to false]
**currency** | **String** | {\&quot;description\&quot;:\&quot;[Required if and only if &#x60;productRatePlan&#x60; is omitted] The currency of the product-rate-plan &amp;mdash; as specified by a three-character ISO 4217 currency code (i.e. USD).\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | 


