# Bfwd::MigrationRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**created** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was created.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**next_subscription_name** | **String** | {\&quot;description\&quot;:\&quot;Name to which the subscription will change upon successful migration.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**next_subscription_description** | **String** | {\&quot;description\&quot;:\&quot;Description to which the subscription will change upon successful migration.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**product** | **String** | {\&quot;description\&quot;:\&quot;The product to which the subscription will be migrated.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**product_rate_plan** | **String** | {\&quot;description\&quot;:\&quot;The rate plan (of some product) to which the subscription will be migrated.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**invoicing_type** | **String** | {\&quot;default\&quot;:\&quot;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Aggregated&lt;/span&gt;\&quot;,\&quot;description\&quot;:\&quot;The strategy for how to raise invoices for charges caused by this migration.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Immediate&lt;/span&gt; &amp;mdash; Generate straight-away an invoice containing these charges.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Aggregated&lt;/span&gt; &amp;mdash; Add these charges to the next invoice which is generated naturally &amp;mdash; i.e. the invoice raised at the current period&#39;s end.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**mappings** | [**Array&lt;PricingComponentMigrationValue&gt;**](PricingComponentMigrationValue.md) | {\&quot;description\&quot;:\&quot;List of pricing components and quantities thereof to be consumed in the new rate plan.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**pricing_behaviour** | **String** | {\&quot;default\&quot;:\&quot;DifferenceProRated\&quot;,\&quot;description\&quot;:\&quot;Pricing behaviour defines how migration charges are calculated.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;DifferenceProRated&lt;/span&gt; &amp;mdash; Calculate the difference between in-advance charges of the existing and new rate-plan, then pro-rate based on time remaining.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;None&lt;/span&gt; &amp;mdash; Set the migration charge as zero cost.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Full&lt;/span&gt; &amp;mdash; Set the costs as the total of the new rate-plan&#39;s in-advance charges.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Difference&lt;/span&gt; &amp;mdash; The same calculation as in &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;DifferenceProRated&lt;/span&gt;, but with no pro-ration applied.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;ProRated&lt;/span&gt; &amp;mdash; When moving to a rate-plan of the same duration: Pro-rates the in-advance charges of the new rate-plan.&lt;br&gt;When moving to a rate-plan of a different duration: A credit-note will be issued for the price of any remaining time on the existing plan&#39;s billing period.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**dry_run** | **BOOLEAN** | {\&quot;default\&quot;:\&quot;false\&quot;,\&quot;description\&quot;:\&quot;Calculate the effects of migration but do not actually perform a migration.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] [default to false]


