# Bfwd::NestedChargeRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**name** | **String** | {\&quot;description\&quot;:\&quot;Friendly name given to the charge to help identify it.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**description** | **String** | {\&quot;description\&quot;:\&quot;\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**amount** | **Float** | {\&quot;description\&quot;:\&quot;Monetary amount for which to charge. Used only for ad-hoc charges i.e charges not associated with any pricing component. Applicable if pricingComponent is NOT defined\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**tax_amount** | **BOOLEAN** | {\&quot;default\&quot;:false,\&quot;description\&quot;:\&quot;Applicable if amount is specified and indicates whether or not to apply tax in addition to the value specified.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;true&lt;/span&gt; &amp;mdash; Tax will be added on top of the nominal price specified in amount &amp;mdash; in accordance with any taxation strategies you have defined.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;false&lt;/span&gt; &amp;mdash; No tax will be applied on top of the price specified in amount.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**period_start** | **DateTime** | {\&quot;default\&quot;:\&quot;Now\&quot;,\&quot;description\&quot;:\&quot;Start of the interval to which the charge applies. This can be used to apply a charge across partial or multiple periods. Pro-rating the price of pricingComponents purchased\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**period_end** | **DateTime** | {\&quot;default\&quot;:\&quot;(End of current period)\&quot;,\&quot;description\&quot;:\&quot;(Applicable only if &#x60;pricingComponent&#x60; is defined)&lt;br&gt;End of the interval to which the charge applies. Used in pro-rata calculation\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**charge_type** | **String** | {\&quot;default\&quot;:\&quot;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Debit&lt;/span&gt;\&quot;,\&quot;description\&quot;:\&quot;Whether this charge represents an increase or decrease in invoice cost&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Credit&lt;/span&gt; &amp;mdash; This results in a reduction to the invoice cost&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Debit&lt;/span&gt; &amp;mdash; This will increase the invoice cost\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**trial** | **BOOLEAN** | {\&quot;default\&quot;:\&quot;false\&quot;,\&quot;description\&quot;:\&quot;Whether the charge is meant in the context of a trial.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;false&lt;/span&gt; &amp;mdash; This is a non-trial charge, so funds will be sought from the customer.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;true&lt;/span&gt; &amp;mdash; This is a trial charge, soThe charge can be considered &#39;Paid&#39; without taking any funds from the customer.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**product** | **String** | {\&quot;description\&quot;:\&quot;[Required only if the &#x60;productRatePlan&#x60; field is populated with a name (as opposed to an ID)]. The ID or name of the product rate plan to which the referenced rate plan belongs.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**product_rate_plan** | **String** | {\&quot;description\&quot;:\&quot;[Required only if the &#x60;pricingComponent&#x60; field is populated with a name (as opposed to an ID)]. The ID or name of the rate plan to which the referenced PricingComponent belongs.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**pricing_component** | **String** | {\&quot;description\&quot;:\&quot;Specifies that this charge is for consumption of some quantity of this pricing component (whose name or ID can be provided).&lt;br&gt;If left blank:&lt;br&gt;The charge will be created as &#39;ad-hoc&#39;. That is: a monetary lump sum, associated with no pricing component\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**pricing_component_value** | **Integer** | {\&quot;description\&quot;:\&quot;[Required if pricingComponent is defined]. The value consumed of the pricing component which this charge concerns.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 


