# Bfwd::QuoteRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**created** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was created.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**changed_by** | **String** | { \&quot;description\&quot; : \&quot;ID of the user who last updated the entity.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**product** | **String** | {\&quot;description\&quot;:\&quot;The product for which a price quote is requested.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**product_rate_plan** | **String** | {\&quot;description\&quot;:\&quot;The rate plan (of some product) for which a price quote is requested.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**account_id** | **String** | {\&quot;description\&quot;:\&quot;ID of the account for which a price quote is requested.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**subscription_id** | **String** | {\&quot;description\&quot;:\&quot;ID of the subscription for which a price quote is requested.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**subscription_version_id** | **String** | {\&quot;description\&quot;:\&quot;version ID of the subscription for which a price quote is requested.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**quote_for** | **String** | {\&quot;default\&quot;:\&quot;RecurringPeriod\&quot;,\&quot;description\&quot;:\&quot;Subscription scenario with which the quote is concerned.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**prorated** | **BOOLEAN** | {\&quot;default\&quot;:true,\&quot;description\&quot;:\&quot;Whether or not to pro-rate the price (if the quote concerns a time interval containing a partial period).\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] [default to false]
**free** | **BOOLEAN** | {\&quot;default\&quot;:false,\&quot;description\&quot;:\&quot;Whether or not to present a waived final price in the quote.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] [default to false]
**include_applied_coupons** | **BOOLEAN** | {\&quot;default\&quot;:true,\&quot;description\&quot;:\&quot;Whether or not to include coupons which have already been applied to the subscription.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] [default to false]
**period_start** | **DateTime** | {\&quot;default\&quot;:\&quot;(Now)\&quot;,\&quot;description\&quot;:\&quot;The time-beginning of the interval with which the quote is concerned. This can be used to request a quote across partial or multiple periods &amp;mdash; potentially pro-rating its price.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**period_end** | **DateTime** | {\&quot;default\&quot;:\&quot;(End of current period)\&quot;,\&quot;description\&quot;:\&quot;The time-ending of the interval with which the quote is concerned. This can be used to request a quote across partial or multiple periods &amp;mdash; potentially pro-rating its price.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**remaining_credit_behaviour** | **String** | {\&quot;default\&quot;:\&quot;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Rollover&lt;/span&gt;\&quot;,\&quot;description\&quot;:\&quot;Defines the behaviour applied to any outstanding credit resulting from the application of the charge..&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Rollover&lt;/span&gt; &amp;mdash; Outstanding credit is returned to the accounts credit pool.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Discard&lt;/span&gt; &amp;mdash; Outstanding credit is lost.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**quantities** | [**Array&lt;QuoteRequestValue&gt;**](QuoteRequestValue.md) | {\&quot;description\&quot;:\&quot;A list of pricing components (and their values) to consider in calculating the quote.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**coupon_codes** | **Array&lt;String&gt;** | {\&quot;description\&quot;:\&quot;A list of coupon codes to consider in calculating the quote.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**pricing_behaviour** | **String** | { \&quot;description\&quot; : \&quot;Pricing behaviour defines how migration charges are calculated. &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;DifferenceProRated&lt;/span&gt; calculates the difference between in-advance charges of the existing and new rate-plan, then pro-rates based on time remaining. &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;None&lt;/span&gt; sets the migration charge as zero cost. &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Full&lt;/span&gt; sets the costs as the total of the new rate-plans in-advance charges.  &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Difference&lt;/span&gt; is the same calculation as &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;DifferenceProRated&lt;/span&gt; but no pro-ration is applied.  &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;ProRated&lt;/span&gt; differs depending on two cases; when moving to a rate-plan of the same duration it pro-rates the in-advance charges of the new rate-plan. If the duration is different, a credit-note will be issued any remaining time on the existing plans billing period.\&quot;, \&quot;default\&quot; : \&quot;DifferenceProRated\&quot;,  \&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;] } | 


