# Bfwd::Subscription

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**created** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was created.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**changed_by** | **String** | { \&quot;description\&quot; : \&quot;ID of the user who last updated the entity.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**updated** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was last updated.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**metadata** | [**DynamicMetadata**](DynamicMetadata.md) | { \&quot;description\&quot; : \&quot;Add metadata.\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;] } | [optional] 
**id** | **String** | {\&quot;description\&quot;:\&quot;\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | 
**version_id** | **String** | {\&quot;description\&quot;:\&quot;\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**crm_id** | **String** | {\&quot;description\&quot;:\&quot;\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 
**account_id** | **String** | {\&quot;description\&quot;:\&quot;\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**organization_id** | **String** | {\&quot;description\&quot;:\&quot;Organization associated with the subscription.\&quot;,\&quot;verbs\&quot;:[]} | 
**product_id** | **String** | {\&quot;description\&quot;:\&quot;\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | 
**product_rate_plan_id** | **String** | {\&quot;description\&quot;:\&quot;Identifier of the rate-plan being billed for.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | 
**parent_id** | **String** | {\&quot;description\&quot;:\&quot;\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**name** | **String** | {\&quot;description\&quot;:\&quot;User definable friendly name for the subscription.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | 
**description** | **String** | {\&quot;description\&quot;:\&quot;\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 
**type** | **String** | {\&quot;default\&quot;:\&quot;dependent on product\&quot;, \&quot;description\&quot;:\&quot;\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**state** | **String** | {\&quot;PUT_description\&quot;:\&quot;A &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Provisioned&lt;/span&gt; subscription can be updated to either &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Trial&lt;/span&gt; or &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;AwaitingPayment&lt;/span&gt;, this will start the subscription. Any updates to the state of a non-&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Provisioned&lt;/span&gt; will be ignored. To cancel or otherwise amend a subscription please use the explict amendment calls.\&quot;, \&quot;description\&quot;:\&quot;A &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Provisioned&lt;/span&gt; subscription will not begin until marked as &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Trial&lt;/span&gt; or &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;AwaitingPayment&lt;/span&gt;. Trial subscriptions transition to &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;AwaitingPayment&lt;/span&gt; when the trial period is over. On subscription renewal the state becomes &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;AwaitingPayment&lt;/span&gt;. Once outstanding invoices are paid the state changes to &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Paid&lt;/span&gt;. A subscription is set as either &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Failed&lt;/span&gt; or left as &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;AwaitingPayment&lt;/span&gt;, depending on the rate-plan configuration. If a subscription is non-recurring or fixed-term and ends naturally, it will be marked as &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Expired&lt;/span&gt;. If all payment attempts have failed a subscription is marked as &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Cancelled&lt;/span&gt; if it has been manually ended. Once a subscription is marked as &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Failed&lt;/span&gt;, &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Expired&lt;/span&gt;, or &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Cancelled&lt;/span&gt; no invoices other than a final invoice will be issued. Note: Updating account card details will not lead to BillForward automatically retrying payment, manual payment attempts can be made.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | 
**current_period_start** | **DateTime** | {\&quot;description\&quot;:\&quot;Start of the current invoice period. At the end of this period, a new new invoice will be generated\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**current_period_end** | **DateTime** | {\&quot;description\&quot;:\&quot;End of the current period invoiced for. This can be manually updated to extend trials or delay invoice generation.\&quot;,\&quot;verbs\&quot;:[\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 
**contract_start** | **DateTime** | {\&quot;description\&quot;:\&quot;start of the contracted period.  This will be after a trial, if one exists\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**subscription_end** | **DateTime** | {\&quot;description\&quot;:\&quot;When a subscription will end. This may be in the future if the cancellation is at the end of the current period.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**current_period_end_explicit** | **DateTime** | {\&quot;description\&quot;:\&quot;Override for the initial subscription period. Allows periods to align to a date or time regardless of purchase date/time.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 
**initial_period_start** | **DateTime** | {\&quot;description\&quot;:\&quot;Start of the first successful period\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | 
**successful_periods** | **Integer** | {\&quot;description\&quot;:\&quot;Number of paid-for periods billing, excluding trials, since the subscription started.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**total_periods** | **Integer** | {\&quot;description\&quot;:\&quot;Total number of subscription periods.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**trial_end** | **DateTime** | {\&quot;description\&quot;:\&quot;The end time of the trial period, if one existed\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | 
**dunning** | **BOOLEAN** | {  \&quot;default\&quot;:\&quot;false\&quot;, \&quot;description\&quot;:\&quot;Are there outstanding invoices which are currently in dunning.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;, \&quot;PUT\&quot;, \&quot;POST\&quot;]} | [optional] [default to false]
**locked** | **String** | {\&quot;description\&quot;:\&quot;If the subscription is locked, it will not be processed by the system\&quot;,\&quot;verbs\&quot;:[]} | [optional] 
**managed_by** | **String** | {\&quot;description\&quot;:\&quot;Which system is responsible for managing the subscription.\&quot;,\&quot;verbs\&quot;:[]} | [optional] 
**version_start** | **DateTime** | {\&quot;description\&quot;:\&quot;When the current version of the subscription started.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | 
**version_end** | **DateTime** | {\&quot;description\&quot;:\&quot;When the current version of the subscription ended, null indicates current version.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**version_number** | **Integer** | {\&quot;description\&quot;:\&quot;Incremental version number of the subscription, starts at 1.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | 
**credit_enabled** | **BOOLEAN** | {  \&quot;default\&quot;:\&quot;true\&quot;, \&quot;description\&quot;:\&quot;Can credit-notes be used to pay outstanding invoices for this subscription.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;, \&quot;PUT\&quot;, \&quot;POST\&quot;]} | [optional] [default to false]
**aggregate_all_subscriptions_on_account** | **BOOLEAN** | {  \&quot;default\&quot;:\&quot;true\&quot;, \&quot;description\&quot;:\&quot;Whether the subscription will aggregate all other subscriptions on the account.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;, \&quot;PUT\&quot;, \&quot;POST\&quot;]} | [optional] [default to false]
**pricing_component_values** | [**Array&lt;PricingComponentValue&gt;**](PricingComponentValue.md) | {\&quot;description\&quot;:\&quot;The quantities for each pricing component of the rate-plan. Values should be set for all pricing components of the rate-plan apart from the usage components. Usage components should be added when the usage is known, this is often after the end of the current billing cycle.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;, \&quot;POST\&quot;]} | [optional] 
**payment_method_subscription_links** | [**Array&lt;PaymentMethodSubscriptionLink&gt;**](PaymentMethodSubscriptionLink.md) |  | [optional] 
**fixed_terms** | [**Array&lt;FixedTerm&gt;**](FixedTerm.md) | {\&quot;description\&quot;:\&quot;List of fixed terms that have been or are applied to the subscription\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**current_time** | **DateTime** | {\&quot;description\&quot;:\&quot;The current time &amp;mdash; from the point of view of the subscription.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | 
**time_offset** | **Integer** | {\&quot;description\&quot;:\&quot;How far in the future is the entity (in seconds) compared to the BillForward server&#39;s time.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**payment_terms** | **Integer** |  | [optional] 
**purchase_order** | **String** | { \&quot;default\&quot;: \&quot; \&quot;, \&quot;description\&quot;:\&quot;Purchase order associated with the subscription. If specified this is copied to any invoices issued for this subscription.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**failed_payment_behaviour** | **String** | {\&quot;default\&quot;:\&quot;None\&quot;,\&quot;description\&quot;:\&quot;The action that should be taken, should an invoice for some subscription to this rate plan remain unpaid despite the dunning period&#39;s being exceeded.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;CancelSubscription&lt;/span&gt; &amp;mdash; Demotes the subscription to the &#x60;Failed&#x60; state as soon as the dunning period is exceeded.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;None&lt;/span&gt; &amp;mdash; The subscription is allowed to continue in the &#x60;AwaitingPayment&#x60; state indefinitely even if the dunning period is exceeded.For slow payment cycles &amp;mdash; or when manual invoice remediation is common &amp;mdash; &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;None&lt;/span&gt; is recommended.&lt;br&gt;In a heavily-automated SaaS environment, automatic cancellation via &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;CancelSubscription&lt;/span&gt; is recommended.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 


