# Bfwd::UpdateSubscriptionRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **String** | {\&quot;description\&quot;:\&quot;ID of the Subscription you wish to update.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | 
**name** | **String** | {\&quot;description\&quot;:\&quot;New name to assign to the updated subscription. This is primarily for your benefit &amp;mdash; for example, to enable you to identify subscriptions at a glance in the BillForward web interface (e.g. &#39;Customer 1425, guy@mail.com, Premium membership&#39;).\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**description** | **String** | {\&quot;description\&quot;:\&quot;New description to assign to the updated subscription. This is primarily for your benefit &amp;mdash; for example, you could write here the mechanism through which you obtained this customer. (e.g. &#39;Customer obtained through Lazy Wednesdays promotion&#39;).\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**start** | **DateTime** | {\&quot;description\&quot;:\&quot;[Can only be changed if subscription is still in Provisioned state] ISO 8601 UTC DateTime (e.g. 2015-06-16T11:58:41Z) describing the date at which the subscription should enter its first service period.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**_end** | **DateTime** | {\&quot;description\&quot;:\&quot;[Can only be changed if subscription is still in Provisioned state] ISO 8601 UTC DateTime (e.g. 2015-06-16T11:58:41Z) describing the date at which the subscription should finish its first service period.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**state** | **String** | {\&quot;description\&quot;:\&quot;[Can only be changed if subscription is still in Provisioned state] The state into which you wish to move the updated subscription.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;AwaitingPayment&lt;/span&gt; &amp;mdash; The subscription is activated. After &#x60;start&#x60; time is surpassed, it will begin service and raise its first invoice.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**parent_id** | **String** | {\&quot;description\&quot;:\&quot;ID of a parent subscription which will collect the charges raised by this subscription. The parent becomes responsible for paying those charges.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**aggregate_all_subscriptions_on_account** | **BOOLEAN** | {\&quot;description\&quot;:\&quot;Whether this subscription should become an &#39;aggregating subscription&#39;, collecting charges (starting now) from all other subscriptions (current and future) belonging to this BillForward Account.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] [default to false]
**failed_payment_behaviour** | **String** | {\&quot;default\&quot;:\&quot;None\&quot;,\&quot;description\&quot;:\&quot;The action that should be taken, should an invoice for some subscription to this rate plan remain unpaid despite the dunning period&#39;s being exceeded.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;CancelSubscription&lt;/span&gt; &amp;mdash; Demotes the subscription to the &#x60;Failed&#x60; state as soon as the dunning period is exceeded.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;None&lt;/span&gt; &amp;mdash; The subscription is allowed to continue in the &#x60;AwaitingPayment&#x60; state indefinitely even if the dunning period is exceeded.For slow payment cycles &amp;mdash; or when manual invoice remediation is common &amp;mdash; &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;None&lt;/span&gt; is recommended.&lt;br&gt;In a heavily-automated SaaS environment, automatic cancellation via &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;CancelSubscription&lt;/span&gt; is recommended.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 


