# Bfwd::ProductRatePlan

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**created** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was created.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**changed_by** | **String** | { \&quot;description\&quot; : \&quot;ID of the user who last updated the entity.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**updated** | **DateTime** | { \&quot;description\&quot; : \&quot;The UTC DateTime when the object was last updated.\&quot;, \&quot;verbs\&quot;:[] } | [optional] 
**metadata** | [**DynamicMetadata**](DynamicMetadata.md) | { \&quot;description\&quot; : \&quot;Add metadata.\&quot;, \&quot;verbs\&quot;:[\&quot;POST\&quot;] } | [optional] 
**id** | **String** | {\&quot;description\&quot;:\&quot;ID uniquely identifying this rate plan.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**crm_id** | **String** | {\&quot;description\&quot;:\&quot;Customer-relationship-management ID of the rate plan.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;,\&quot;PUT\&quot;,\&quot;POST\&quot;]} | [optional] 
**product_id** | **String** | {\&quot;description\&quot;:\&quot;ID of the product to which this rate plan belongs. A product is essentially a collection of rate plans, and describes the service conferred to a customer upon subscription to any of said product&#39;s rate plans. The product serves also as a template from which its rate plans can infer default attributes.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**currency** | **String** | {\&quot;description\&quot;:\&quot;The currency of the product-rate-plan &amp;mdash; as specified by a three-character ISO 4217 currency code (i.e. USD).\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**tax_status** | **String** | {\&quot;default\&quot;:\&quot;inclusive\&quot;,\&quot;description\&quot;:\&quot;The tax status of the product-rate-plan &amp;mdash; either inclusive or exclusive.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;exclusive&lt;/span&gt;pricing indicates that the cost of the Pricing Components do not include tax; when BillForward generates an Invoice, the tax will be calculated with this price as a base. &lt;br&gt;Tax-&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;inclusive&lt;/span&gt;pricing indicates that the Pricing components include Tax. BillForward will still calculate tax on each invoice. Tax will be calculated from the sales price.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | 
**failed_payment_behaviour** | **String** | {\&quot;default\&quot;:\&quot;None\&quot;,\&quot;description\&quot;:\&quot;The action that should be taken, should an invoice for some subscription to this rate plan remain unpaid despite the dunning period&#39;s being exceeded.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;CancelSubscription&lt;/span&gt; &amp;mdash; Demotes the subscription to the &#x60;Failed&#x60; state as soon as the dunning period is exceeded.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;None&lt;/span&gt; &amp;mdash; The subscription is allowed to continue in the &#x60;AwaitingPayment&#x60; state indefinitely even if the dunning period is exceeded.For slow payment cycles &amp;mdash; or when manual invoice remediation is common &amp;mdash; &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;None&lt;/span&gt; is recommended.&lt;br&gt;In a heavily-automated SaaS environment, automatic cancellation via &lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;CancelSubscription&lt;/span&gt; is recommended.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | 
**duration** | **Integer** | {\&quot;description\&quot;:\&quot;Number of length-measures which constitute the rate plan&#39;s period. If left unspecified: the rate plan will use the same &#x60;duration&#x60; number as the Product to which it belongs.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**duration_period** | **String** | {\&quot;description\&quot;:\&quot;Measure describing the magnitude of the rate plan&#39;s period. If left unspecified: the rate plan will use the same &#x60;durationPeriod&#x60; magnitude as the Product to which it belongs.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | 
**trial** | **Integer** | {\&quot;default\&quot;:0,\&quot;description\&quot;:\&quot;Number of trial-length-measures which constitute the rate plan&#39;s trial period. If left unspecified: the rate plan will use the same &#x60;trial&#x60; number as the Product to which it belongs.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 
**trial_period** | **String** | {\&quot;default\&quot;:\&quot;none\&quot;,\&quot;description\&quot;:\&quot;Measure describing the magnitude of the rate plan&#39;s trial period. If left unspecified: the rate plan will use the same &#x60;trialPeriod&#x60; magnitude as the Product to which it belongs.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 
**product_type** | **String** | {\&quot;default\&quot;:\&quot;recurring\&quot;,\&quot;description\&quot;:\&quot;The frequency of the rate plan &amp;mdash; either recurring or non-recurring. If left unspecified: the rate plan will use the same &#x60;productType&#x60; frequency as the Product to which it belongs.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 
**pro_rata_mode** | **String** | {\&quot;default\&quot;:\&quot;WithCoupon\&quot;,\&quot;description\&quot;:\&quot;The pro-rata mode for the rate plan. &lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;None&lt;/span&gt; &amp;mdash; The pro-rata cost for upgrades will be ignored.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;WithCoupon&lt;/span&gt; &amp;mdash; The pro-rata cost for upgrades will be calculated based on the time remaining for the subscription. Discounts from any attached coupons will be deducted from the pro-rated cost.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;WithoutCoupon&lt;/span&gt; &amp;mdash; The pro-rata cost for upgrades will be calculated based on the time remaining for the subscription. Discounts from any attached coupons will not be deducted from the pro-rated cost. \&quot;,\&quot;verbs\&quot;:[]} | 
**create_zero_valued_invoices** | **BOOLEAN** | {\&quot;default\&quot;:\&quot;true\&quot;,\&quot;description\&quot;:\&quot;Whether invoices are created if they have a zero valued cost before any discounts are applied.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;] } | [default to false]
**name** | **String** | {\&quot;description\&quot;:\&quot;A friendly name &amp;mdash; for your benefit &amp;mdash; used to identify this rate plan within some product in BillForward. The name should reflect the fact that this rate plan provides to the customer a price tiering system within which a subscription to its Product can be made. &lt;br&gt;The rate plan&#39;s name could describe the nature of its price tiering (e.g. \\\&quot;Default pricing\\\&quot;, \\\&quot;Student pricing\\\&quot;).&lt;br&gt;Remember also that rate plans can override the timing prescribed by their product. If your rate plan is defined by its overriding the default timing of its product, then that can be reflected in that rate plan&#39;s name. (e.g. \\\&quot;Student pricing - Annual\\\&quot;).\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | 
**public_name** | **String** | {\&quot;description\&quot;:\&quot;A friendly non-unique name used to identify this product-rate-plan\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 
**valid_from** | **DateTime** | {\&quot;description\&quot;:\&quot;The UTC DateTime specifying when the rate plan is valid from.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**valid_till** | **DateTime** | {\&quot;description\&quot;:\&quot;The UTC DateTime specifying when the product-rate-plan is valid till.\&quot;,\&quot;verbs\&quot;:[\&quot;GET\&quot;]} | [optional] 
**status** | **String** | {\&quot;description\&quot;:\&quot;The current status of the rate plan.\&quot;,\&quot;verbs\&quot;:[]} | [optional] 
**migration_behaviour** | **String** | {\&quot;default\&quot;:\&quot;CreditAccount\&quot;,\&quot;description\&quot;:\&quot;The action that should be taken, should the pro-rata calculation result in a negative value.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;NoCharge&lt;/span&gt; &amp;mdash; Don&#39;t return to the customer any money.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;CreditAccount&lt;/span&gt; &amp;mdash; Credit the customer&#39;s account with the amount.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | 
**invoice_issue_type** | **String** | {\&quot;default\&quot;:\&quot;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Immediate&lt;/span&gt;\&quot;,\&quot;description\&quot;:\&quot;The strategy for how invoices for this plan will be issued.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Immediate&lt;/span&gt; &amp;mdash; All generated invoices move immediately to the &#39;Unpaid&#39; state &amp;mdash; beginning the payment pursuit process.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Delayed&lt;/span&gt; &amp;mdash; All generated invoices begin in the &#39;Pending&#39; state. An &#39;Issue Invoice&#39; amendment is scheduled (based on the rate plan&#39;s &#x60;issueDuration&#x60; and &#x60;issuePeriod&#x60;) that will move the invoice to the &#39;Unpaid&#39; state (beginning the payment pursuit process) in accordance with the rate plan&#39;s issuance schedule.&lt;br&gt;&lt;span class&#x3D;\\\&quot;label label-default\\\&quot;&gt;Manual&lt;/span&gt; &amp;mdash; All generated invoices sit in the &#39;Pending&#39; state &amp;mdash; they will not be issued to the customer unless explicit action is taken. This gives you an opportunity to review or recalculate the invoice.\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**issue_duration** | **Integer** | {\&quot;description\&quot;:\&quot;Number of issue-length-measures between issuance of invoices for this rate plan.\&quot;\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**issue_period** | **String** | {\&quot;description\&quot;:\&quot;Measure describing the magnitude of the invoice issuance period.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**taxation** | [**Array&lt;MutableBillingEntity&gt;**](MutableBillingEntity.md) | {\&quot;description\&quot;:\&quot;A list linking taxation strategies to the rate plan.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;,\&quot;PUT\&quot;]} | [optional] 
**fixed_term_definitions** | [**Array&lt;MutableBillingEntity&gt;**](MutableBillingEntity.md) | {\&quot;description\&quot;:\&quot;A list linking \\\&quot;Fixed-Term Definitions\\\&quot; to the rate plan.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | [optional] 
**product** | [**Product**](Product.md) | {\&quot;description\&quot;:\&quot;The product to which this rate plan belongs. A product is essentially a collection of rate plans, and describes the service conferred to a customer upon subscription to any of said product&#39;s rate plans. The product serves also as a template from which its rate plans can infer default attributes.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;GET\&quot;]} | [optional] 
**pricing_components** | [**Array&lt;PricingComponent&gt;**](PricingComponent.md) | {\&quot;description\&quot;:\&quot;The pricing-components which describe the price tiering system of this rate plan. A product rate plan may have 1 or more pricing components. Each pricing component represents a different charge associated with the subscription. Pricing components are versioned.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;,\&quot;PUT\&quot;,\&quot;GET\&quot;]} | 
**aggregating_components** | [**Array&lt;AggregatingComponent&gt;**](AggregatingComponent.md) | {\&quot;default\&quot;:\&quot;(empty list)\&quot;,\&quot;description\&quot;:\&quot;List of AggregatingComponents &amp;mdash; these describe pricing components whose prices should be recalculated upon invoice aggregation. For example: two subscriptions&#39; individual consumptions may be neither of them large enough to achieve bulk-buy discounts. When aggregated, though, the same two subscriptions&#39; consumption may add up to a quantity which does merit a bulk buy discount within your tiering system.\&quot;,\&quot;verbs\&quot;:[\&quot;POST\&quot;]} | [optional] 
**payment_terms** | **Integer** |  | [optional] 


